#include	"stdThread.h"
#include	"SendRecvThread.h"	// MXbhg
#include	"MySyncObject.h"	// IuWFNgg
#include	"define.h"

#define	MAXPENDING			(5)		// ڑobNO(ۗ̐ڑ̃L[̍ő咷)
#define MAX_SOCKET_NUM		(20)	// ڑҗp\Pbg̍ő吔
#define MAX_CONNECTION_NUM	(10)	// ő󂯓ڑ

// ֐̐錾
BOOL CreateAndBindSocket(WORD wPort);	// ڑ҂p\Pbg̍쐬ƖOt
BOOL DestroySocket(SOCKET &fd);			// ؒfƃ\Pbg̔j		
BOOL DoListen();						// \Pbgڑ҂ɂ
BOOL DoAccept();						// ڑ̎e(ڑς݃\Pbg쐬)
void Stop();							// ׂẴ\Pbgj
BOOL CheckKey();						// L[͂̌
BOOL KillZombei();						// ]rԂ̃Xbhj
BOOL SerializeSendData();				// f[^VACYeMXbh̑Mobt@Ɋi[

// ϐ̐錾
SOCKET	m_fdServer[MAX_SOCKET_NUM];		// ҋ@p\Pbg
int		m_iSockCount;					// ҋ@\Pbg̐
CSendRecvThread		*m_pCSendRecvThread[MAX_CONNECTION_NUM] = { NULL };
ConnectionInfoRec	*m_pConInfo[MAX_CONNECTION_NUM] = { NULL };
CMySyncObject		*m_pCMySyncObject = NULL;

int main(int argc, char *argv[])
{
	int		iRet = -1;
	int		ii;

	Locate(1, 1, 2);
	m_pCMySyncObject = new CMySyncObject();
	m_pCMySyncObject->Initialize();
	// Np[^`FbN
	if (argc != 2)
	{
		fprintf(stderr, "Usage:  %s <Server Port>\n", argv[0]);
		goto L_END;
	}

	// ϐ̏
	for (ii = 0; ii < MAX_SOCKET_NUM; ++ii)
		m_fdServer[ii] = INVALID_SOCKET;

	// ڑ҂\Pbg̍쐬ƖOt
	// bindς݂̃\Pbgm_fdServer[]Ɋi[
	if (CreateAndBindSocket((WORD)atol(argv[1])) == FALSE)
		goto L_END;
	// ڑҋ@Ԃɂ
	// m_fdServer[]Ɋi[Ă\Pbgڑ҂ɂȂ
	if (DoListen() == FALSE)
		goto L_END;
	// ڑvɑ΂Đڑς݃\Pbg쐬
	// MXbh̍쐬]rXbh̔js
	if (DoAccept() == FALSE)
		goto L_END;

	iRet = 0;
L_END:
	// ؒfƂׂẴ\Pbg̔j
	Stop();
	m_pCMySyncObject->Uninitialize();
	SAFE_DELETE(m_pCMySyncObject)
	return(iRet);
}

//----------------------------------------------
// function
//    ҋ@p\Pbg̍쐬bind̎{
// parameter
//    WORD	wPort	[in]|[gԍ
// return
//    TRUE/FALSE
//----------------------------------------------
BOOL CreateAndBindSocket(WORD wPort)
{
	BOOL	fRet = TRUE;
	struct addrinfo	hints, *pres = NULL, *pTemp = NULL;
	char	szPort[NI_MAXSERV];
	int 	on;

	fprintf(stderr, "CreateAndBindSocket()\n");

	m_iSockCount = 0;
	// Xg[^őҋ@\ȃAhX̏
	memset(&hints, 0, sizeof(hints));
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_flags = AI_PASSIVE;
	DISABLE_C4996
	sprintf(szPort, "%d", wPort);
	ENABLE_C4996

	if (getaddrinfo(NULL, szPort, &hints, &pres) == 0)
	{
		// Ԃpres̒Ɋi[Ăgp
		pTemp = pres;
		while ((pTemp != NULL) && (m_iSockCount < MAX_SOCKET_NUM))
		{
			// Socket̍쐬, bind̎s
			// \Pbg쐬
			m_fdServer[m_iSockCount] = socket(pTemp->ai_family, pTemp->ai_socktype, pTemp->ai_protocol);
			if (m_fdServer[m_iSockCount] == INVALID_SOCKET)
				goto L_NEXT;
			fprintf(stderr, "%d %d %d %d\n", (int)m_fdServer[m_iSockCount], pTemp->ai_family, AF_INET, AF_INET6);
#ifdef IPV6_V6ONLY
			// IPv6\PbgIPv4ˉeAhXgpȂ悤ɐݒ
			if (pTemp->ai_family == AF_INET6)
			{
				on = 1;
				if (setsockopt(m_fdServer[m_iSockCount], IPPROTO_IPV6, IPV6_V6ONLY, (char *)&on, sizeof(on)) < 0)
				{
					DispErrorMsg("Err:setsockopt");
					goto L_NEXT;
				}
			}
#endif
			// N[YɍbindłȂԂ̉
			on = 1;
			setsockopt(m_fdServer[m_iSockCount], SOL_SOCKET, SO_REUSEADDR, (char *)&on, sizeof(on));
			// bind̎s
			if (bind(m_fdServer[m_iSockCount], pTemp->ai_addr, (int)pTemp->ai_addrlen) == SOCKET_ERROR)
			{
				// bindɎsÃ\PbgjĎ̃\Pbg̏s
				DispErrorMsg("Err:bind");
				DestroySocket(m_fdServer[m_iSockCount]);
				goto L_NEXT;
			}
			++m_iSockCount;
		L_NEXT:
			pTemp = pTemp->ai_next;			// ̏
		}
		freeaddrinfo(pres);
	}
	if (m_iSockCount == 0)					// ЂƂbindłȂƂ͎sԂ
		fRet = FALSE;
	return(fRet);
}

//----------------------------------------------
// function
//    ҋ@p\Pbgڑ҂Ԃɂ
// parameter
//    Ȃ
// return
//    TRUE/FALSE
//----------------------------------------------
BOOL DoListen()
{
	BOOL		fRet = FALSE;
	int			ii;

	fprintf(stderr, "DoListen()\n");
	for (ii = 0; ii < m_iSockCount; ++ii)
	{
		if (listen(m_fdServer[ii], MAXPENDING) == SOCKET_ERROR)
			continue;
		fRet = TRUE;
	}
	return(fRet);
}

//----------------------------------------------
// function
//    ڑv̎󂯓(ڑς݃\Pbg̍쐬)
//    MXbh̊Ǘ
// parameter
//    Ȃ
// return
//    TRUE/FALSE
//----------------------------------------------
BOOL DoAccept()
{
	BOOL				fRet = FALSE;
	sockaddr_storage	ClntAddr;	// ڑNCAg̃AhX
	socklen_t			iClntLen;	// ڑNCAg̃AhX̃TCY
	char				szHostAddr[NI_MAXHOST];
	int					ii;
	pollfd				fds[MAX_SOCKET_NUM] = {0};
	int					jj;			// őڑ܂őMXbh𓮂
	SOCKET				fdClient;	// ̂߂accepťʂL

	fprintf(stderr, "DoAccept()\n");
	for (ii = 0; ii < m_iSockCount; ++ii)
	{
		fds[ii].fd = m_fdServer[ii];
		fds[ii].events = POLLIN;				// MCxgݒ
	}

	while (1)
	{
		KillZombei();				// ]rԂ̃Xbh͔j
		SerializeSendData();
		poll(fds, m_iSockCount, 10);
		// L[͂Œf
		if (CheckKey())
		{
			fprintf(stderr, "  OK:Abort by key\n");
			break;
		}
		for (ii = 0; ii < m_iSockCount; ++ii)
		{
			if (fds[ii].revents & POLLERR)			// G[
				DispErrorMsg("Err:DoAccept");
			else if(fds[ii].revents & POLLIN)		// MCxg
			{
				iClntLen = sizeof(ClntAddr);		// ڑAhXi[\̂̃TCY
				// eƂ̃\PbgLAMXbh邩ؒf邩Ɏgp
				if ((fdClient = accept(m_fdServer[ii], (sockaddr *)&ClntAddr, &iClntLen)) == INVALID_SOCKET)
				{
					// s̐ڑv
					DispErrorMsg("Err:accept");
					continue;
				}
				else
				{
					// fdClientɂ͐ڑς݂̃\Pbgi[Ă
					// ̏񂩂AIPAhX𒲂ׂ
					if (getnameinfo((struct sockaddr *) &ClntAddr, (socklen_t)iClntLen,
						szHostAddr, sizeof(szHostAddr), NULL, 0, NI_NUMERICHOST) == 0)
					{
						fprintf(stderr, "%s\n", szHostAddr);
					}
					// ڑɗ]TCSendRecvThread̃CX^X쐬s
					// Ȃ΁Aؒf
					fRet = FALSE;
					for (jj = 0; jj < MAX_CONNECTION_NUM; ++jj)
					{
						if (m_pCSendRecvThread[jj] == NULL)
						{
							m_pConInfo[jj] = (ConnectionInfoRec *)calloc(1, sizeof(ConnectionInfoRec));
							m_pConInfo[jj]->pCMySyncObject = m_pCMySyncObject;
							m_pConInfo[jj]->fdClient = fdClient;
							m_pCSendRecvThread[jj] = new CSendRecvThread(m_pConInfo[jj]);
							m_pCSendRecvThread[jj]->Begin();
							fRet = TRUE;
							break;
						}
					}
					if (fRet == FALSE)
						DestroySocket(fdClient);
				}
			}
		}
	}
	return(fRet);
}


//----------------------------------------------
// function
//    TCP\Pbg̔j
// parameter
//    SOCKET		&fd[in/out]j\Pbg
// return
//    TRUE/FALSE
//----------------------------------------------
BOOL DestroySocket(SOCKET &fd)
{
	if (fd != INVALID_SOCKET)
	{
		fprintf(stderr, "DestroySocket()\n");
		shutdown(fd, SHUT_RDWR);     // MM~
		close(fd);
		fd = INVALID_SOCKET;
	}
	return(TRUE);
}

//----------------------------------------------
// function
//    ؒfA\Pbg̔jAMXbh̔j
// parameter
//    Ȃ
// return
//    Ȃ
//----------------------------------------------
void Stop()
{
	int		ii;

	fprintf(stderr, "Stop()\n");
	//MXbh̔j, ڑς݃\Pbg̔j
	for (ii = 0; ii < MAX_CONNECTION_NUM; ++ii)
	{
		if (m_pCSendRecvThread[ii] != NULL)
		{
			m_pCSendRecvThread[ii]->End();
			m_pCSendRecvThread[ii]->WaitForEnd();
			SAFE_DELETE(m_pCSendRecvThread[ii]);

			DestroySocket(m_pConInfo[ii]->fdClient);
			SAFE_FREE(m_pConInfo[ii])
		}
	}
	// ڑ҂\Pbg̔j
	for (ii = 0; ii < m_iSockCount; ++ii)
		DestroySocket(m_fdServer[ii]);
}

//----------------------------------------------
// function
//	  L[̓`FbN
//	  W͂0Ȃ̂select̂܂܂OKłAK̂߂poll
// parameter
//    Ȃ
// return
//    TRUE:͂
//----------------------------------------------
BOOL CheckKey()
{
	BOOL			fRet = FALSE;
	pollfd			fds[1] = { 0 };
	char			szBuff[81];

	fds[0].fd = 0;					// 0:W 1:Wo 2:WG[
	fds[0].events = POLLIN;			// EnterL[͂Ώۂ
	poll(fds, 1, 10);
	if (fds[0].revents & POLLIN)	// ENTERL[͂
	{
		read(0, szBuff, sizeof(szBuff));
		fRet = TRUE;
	}
	return(fRet);
}

//----------------------------------------------
// function
//	ؒfς݂CSendRecvThreadj
// parameter
//	Ȃ
// return
//	TRUE:j/FALSE:ĵׂȂ
//----------------------------------------------
BOOL KillZombei()
{
	BOOL	fRet = FALSE;
	int		ii;

	for (ii = 0; ii < MAX_CONNECTION_NUM; ++ii)
	{
		if (m_pCSendRecvThread[ii] != NULL)
		{
			if (m_pCSendRecvThread[ii]->IsZombie() == TRUE)
			{
				m_pCSendRecvThread[ii]->End();
				m_pCSendRecvThread[ii]->WaitForEnd();
				SAFE_DELETE(m_pCSendRecvThread[ii]);

				DestroySocket(m_pConInfo[ii]->fdClient);
				SAFE_FREE(m_pConInfo[ii])
					fRet = TRUE;
			}
		}
	}
	return(fRet);
}

//----------------------------------------------
// function
//	]rԂłȂCSendRecvThreadɑMׂf[^
//	VACYđMobt@Ɋi[
// parameter
//	Ȃ
// return
//	TRUE:Zbgׂf[^/FALSE:Ȃ
//----------------------------------------------
BOOL SerializeSendData()
{
	BOOL	fRet = FALSE;
	int		ii, iRecvSize = 0, iRecvIndex = -1;
	char	*pcRecvData = NULL;

	// `bgf[^̕z(pPbgPʂŎoz)
	// ]rԂłȂMClientȊÔׂĂɑMf[^ƂăZbg
	for (ii = 0; ii < MAX_CONNECTION_NUM; ++ii)
	{
		if (m_pCSendRecvThread[ii] != NULL)
		{
			if (m_pCSendRecvThread[ii]->IsZombie() == FALSE)
			{
				iRecvSize = m_pCSendRecvThread[ii]->GetDataForDistributeChat(&pcRecvData);
				if (iRecvSize > 0)
				{
					fRet = TRUE;
					iRecvIndex = ii;
					break;
				}
			}
		}
	}
	if (fRet == TRUE)
	{
		for (ii = 0; ii < MAX_CONNECTION_NUM; ++ii)
		{
			if ((m_pCSendRecvThread[ii] != NULL) && (ii != iRecvIndex))
			{
				if (m_pCSendRecvThread[ii]->IsZombie() == FALSE)
				{
					m_pCSendRecvThread[ii]->SetSendData(pcRecvData, iRecvSize);
				}
			}
		}
	}
	SAFE_FREE(pcRecvData)
	return(fRet);
}

